Subject: trailing [*fixed] section in messages [was: Re: [Dime] DiME WG meeting in Dallas]

From: Anders Kristensen <[email-masked]>
Date: Wed, 01 Mar 2006 11:00:28 -0500

(going through old email)

Victor Fajardo wrote:

> Hi,
> 
> I'd like to post a question regarding the trailing [*fixed] avp set of 
> diameter-message ABNF in Sec 3.2 of the base proto (where: 
> diameter-message = header [*fixed] [*required] [*optional] [*fixed]). 
> I'm not familiar with the history of this layout but in which 
> scenario(s) are trailing fixed avps used ? So far appending of trailing 
> avps are most relevant to proxies and relays but route-records and 
> proxy-info are normally tagged as optional as they should be. And at the 
> moment, there does'nt seem to be any application defining a trailing 
> fixed avp. Maybe this format can be relaxed to help simplify parsing.

I also don't know the reason this was put in but I agree that it doesn't 
seem very useful. Presumably the reason for the first [*fixed] section 
is that having certain AVPs appear early can help allow implementations 
that are interested only in these specific AVPs to not have to parse or 
skip over other AVPs. This reason cannot apply to fixed AVPs at the end 
of messages as one cannot parse from the end (no way of telling where 
the last AVP started without making one's way from the start).

Anders

> 
> Victor
> 
>> Hi all,
>>
>> While our ADs are sorting out the chairing issues, I wanted to solicit
>> input for the Dallas IETF meeting.  I was thinking of summarizing some
>> of the outstanding Diameter Base open issues (if you have any, send them
>> to the mailing list!).  Also, discussion of the upcoming Interop event,
>> Diameter test plans, Diameter MIPv6 work, Diameter QoS working would all
>> be good topics.  Speak up if you have any topics you wish to discuss.
>>
>> John
>>
>> _______________________________________________
>> DiME mailing list
>> [email-masked]
>> https://www1.ietf.org/mailman/listinfo/dime
>>
>>
>>
>>  
>>
> 
> 
> _______________________________________________
> DiME mailing list
> [email-masked]
> https://www1.ietf.org/mailman/listinfo/dime
> 

_______________________________________________
DiME mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/dime

---

From: <[email-masked]>
Date: Sat, 18 Mar 2006 21:15:52 +0200

Someone want to propose a simplified format?  We could add that
to the issues list.

John 

>-----Original Message-----
>From: ext Anders Kristensen [mailto:[email-masked]] 
>Sent: 01 March, 2006 18:00
>To: Victor Fajardo
>Cc: Loughney John (Nokia-NRC/Helsinki); [email-masked]
>Subject: trailing [*fixed] section in messages [was: Re: 
>[Dime] DiME WG meeting in Dallas]
>
>> scenario(s) are trailing fixed avps used ? So far appending of 
>> trailing avps are most relevant to proxies and relays but 
>> route-records and proxy-info are normally tagged as optional as they 
>> should be. And at the moment, there does'nt seem to be any 
>application 
>> defining a trailing fixed avp. Maybe this format can be 
>relaxed to help simplify parsing.
>
>I also don't know the reason this was put in but I agree that 
>it doesn't seem very useful. Presumably the reason for the 
>first [*fixed] section is that having certain AVPs appear 
>early can help allow implementations that are interested only 
>in these specific AVPs to not have to parse or skip over other 
>AVPs. This reason cannot apply to fixed AVPs at the end of 
>messages as one cannot parse from the end (no way of telling 
>where the last AVP started without making one's way from the start).
>
>Anders
>
>> 
>> Victor
>> 
>>> Hi all,
>>>
>>> While our ADs are sorting out the chairing issues, I wanted to 
>>> solicit input for the Dallas IETF meeting.  I was thinking of 
>>> summarizing some of the outstanding Diameter Base open 
>issues (if you 
>>> have any, send them to the mailing list!).  Also, discussion of the 
>>> upcoming Interop event, Diameter test plans, Diameter MIPv6 work, 
>>> Diameter QoS working would all be good topics.  Speak up if 
>you have any topics you wish to discuss.
>>>
>>> John
>>>

---

From: Victor Fajardo <[email-masked]>
Date: Sat, 18 Mar 2006 21:37:50 -0500

Hi,

> Someone want to propose a simplified format? We could add that

My proposal is a minor change to remove the trailing [*fixed] avps in 
Sec. 3.2. The diameter-message ABNF will change from:

"diameter-message = header  [ *fixed] [ *required] [ *optional] [ *fixed]"

to

"diameter-message = header  [ *fixed] [ *required] [ *optional]"

regards,
victor

>>> I'd like to post a question regarding the trailing [*fixed]
>>
>> avp set of
>>
>>> diameter-message = header [*fixed] [*required] [*optional]
>>
>> [*fixed]).
>>